<template>
  <div>
    <label
      class="radio-button"
      :class="{'mb-3': isFreeAnswerDisplayed}"
    >
    <span
      class="custom-radio"
      :class="{checked: isChecked}"
    >
      <input
        :value="inputValue"
        @input="$emit('input', inputValue)"
        type="radio"
        :checked="isChecked"
        class="hidden"
      >
    </span>
      <slot></slot>
    </label>
    <textarea
      v-if="isFreeAnswerDisplayed"
      class="ta-input"
      :value="textValue"
      @input="$emit('textInput', $event.target.value)"
    >

    </textarea>
  </div>
</template>

<script>
export default {
  name: "RadioInput",
  props: {
    value: [String],
    inputValue: {
      type: String,
    },
    textValue: {
      type: String,
    },
    hasFreeAnswer: {
      type: Boolean,
      default: false,
    },
  },
  computed: {
    isChecked() {
      return this.value === this.inputValue
    },
    isFreeAnswerDisplayed() {
      return this.hasFreeAnswer && this.isChecked
    }
  }
}
</script>

<style scoped>
.radio-button {
  @apply cursor-pointer text-sm font-normal p-5 bg-white rounded-lg;
  @apply grid grid-cols-input gap-x-5 items-center hover:text-black;
  @apply hover:shadow-input hover:shadow-input-hover-pressed;
  @apply border border-transparent
}

.radio-button:active {
  @apply bg-grey-light border border-grey-darker
}

.custom-radio {
  @apply relative w-6 h-6 border rounded-full;
}

.custom-radio.checked::before {
  @apply block;
}


.custom-radio::before {
  @apply hidden w-4 h-4 rounded-full bg-black ;
  @apply absolute top-1/2 left-1/2;
  @apply transform -translate-y-1/2 -translate-x-1/2;
  content: '';
}
</style>
